// TempsAttente correspond au temps d'attente (en millisecondes) avant de lancer la musique
unsigned long TempsAttente = 10000;

// TempsDepart est le moment où le bouton est enclenché
unsigned long TempsDepart = 0;

// BoutonAppuye permet de savoir si le bouton a été appuyé ou non
boolean BoutonAppuye = false;

// EtatDuBouton stocke la valeur du bouton (0 si c'est appuyé 1 sinon)
int EtatDuBouton = 0;

#include <Servo.h>

// "pos" correspond à l'angle du servo-moteur
int pos = 10;

Servo monservo;

// ValeurCapteur correspond à la position du potentiomètre
float ValeurCapteur;





void setup() {
  
  //On déclare la broche 2 comme sortie (c'est cette broche qui contrôle le son du téléphone)
  pinMode(2,OUTPUT);
  
  //On déclare la broche 3 comme entrée (c'est sur cette broche que le bouton est branché) 
  pinMode(3,INPUT_PULLUP);
  
  // Au lancement du programme il n'y a pas de courant sur la broche 2 (celle qui contrôle le son)
  digitalWrite(2,LOW );
  
 // On dit au programme sur quelle broche (ici la 9) est branchée le servo-moteur
  monservo.attach(9);

  //On déclare la broche A0 comme entrée (c'est sur cette broche que le potentiomètre est branché)
  pinMode(A0,INPUT);

  //On déclare la broche A1 comme entrée (c'est sur cette broche que l'entrée son est branchée)
  pinMode(A1,INPUT);
  
  monservo.write(pos);

  Serial.begin(9600);
} 


void loop() { 
    // On récupère la valeur du potentiomètre
  ValeurCapteur =analogRead(A0);
 // Si le potentiomètre est tout à gauche le temps d'attente est de 20mn
  if (ValeurCapteur < 64){
    TempsAttente = 20*60L*1000L;
  }
  // Si le potentiomètre est au 2e cran à gauche le temps d'attente est de 19mn

  if (ValeurCapteur >= 64 && ValeurCapteur < 2*64){
    TempsAttente = 19*60*1000L;
    }
 
  // Si le potentiomètre est au 3e cran à gauche le temps d'attente est de 18mn
  if (ValeurCapteur >= 2*64 && ValeurCapteur < 3*64){
    TempsAttente = 18*60*1000L;
  }
  
  // Si le potentiomètre est au 4e cran à gauche le temps d'attente est de 17mn
  if (ValeurCapteur >= 3*64 && ValeurCapteur < 4*64){
    TempsAttente = 17*60*1000L;
  }
  
  // Ainsi de suite...
  for (int ii=4;ii<16;ii++){
    if (ValeurCapteur >= ii*64 && ValeurCapteur < (ii+1)*64)
      TempsAttente = (20-ii)*60*1000L;
  }  

  // On récupère la valeur du bouton branché sur la broche 3
  EtatDuBouton = digitalRead(3);

  // Si le bouton est appuyé on lance le timer
  if (EtatDuBouton == LOW){
    // On met à jour le temps de départ
    TempsDepart = millis();
    // On indique que le bouton a été appuyé
    BoutonAppuye = true;
  }
 
    
  //Tant que l'on a pas atteint 180° (la fin de la rotation du moteur)
  while (pos<= 170  &&  BoutonAppuye) {
  Serial.println(pos);
    
    // On demande au moteur d'aller à l'angle contenu dans "pos"
    monservo.write(pos);
    // On augmente "pos" de 1
   pos=pos+2;
    // On attend un petit temps avant de passer à l'angle suivant
 delay(TempsAttente/80); 
 }
if( BoutonAppuye && pos == 172){
  Serial.println("stopit");
  monservo.detach();
  digitalWrite(2, HIGH);
  delay(600);
  digitalWrite(2, LOW);
  BoutonAppuye = false;
}
}
